!************************************************************
! ԶDate,Բ(-)(+)͸ֵ(=)
! ߣ   2013-04-07
! 
! ܣ(1)Int = Date - Date:
!          2013/04/04 - 2013/04/05 ֵΪ -1
!          2013/04/04 - 2013/04/03 ֵΪ 1
!       (2)Date = Date + Int:
!          2012/04/18 + 4    ֵΪ 2012/04/22
!          2012/04/18 + (-4) ֵΪ 2012/04/14
!       (3)Date = Date - Int:
!          2012/04/18 - 4    ֵΪ 2012/04/14
!          2012/04/18 - (-4) ֵΪ 2012/04/22
!
!************************************************************

module Li913_Date_class
    implicit none
    !غΪ˽
    private DatePlusInt,DateMinusInt,DateMinusDate,AssignToDate,GetDayOrder
    public  LeapYear,Week

    !dateṹ,洢
    type date
    integer(2) year
    integer(1) month,day
    end type
    
    !ز+
    interface operator(+)
		module procedure DatePlusInt
	end interface
	
    !ز-
    interface operator(-)
		module procedure DateMinusDate
		module procedure DateMinusInt
	end interface
	
	!ظֵ=
	interface assignment(=)
		module procedure AssignToDate
	end interface
	
contains

!************************************************************
! (-)(+)غ,Date
! ܣ     DateݺͱӵĽ
!            2012/04/18 + 4 ֵΪ 2012/04/22
!            2012/04/18 - 4 ֵΪ 2012/04/14
! ֵ   DatePlusInt(Date)
!  a(Dateͱ),b(4ֽ)
!************************************************************
function DateMinusInt(a,b)
	implicit none
	type(date),intent(in) :: a
	integer(4),intent(in) :: b
	type(date) DateMinusInt
	
	DateMinusInt=DatePlusInt(a,-b)
end function DateMinusInt

	function DatePlusInt(a,b) 
	    implicit none
	    type(date),intent(in) :: a
	    integer(4),intent(in) :: b
	    type(date) DatePlusInt
	    integer(2) y,td
	    integer(4) days
	    
	    y=a%year
	    days=GetDayOrder(y,a%month,a%day)
	    if(b==0) then
	        DatePlusInt=a
	    else if(b>0) then
	        days=days+b
            td=daysofyear(y)
	        do while(days>td)
	            y=y+1
	            days=days-td
	            td=daysofyear(y)
	        end do
	        DatePlusInt=todate(y,int(days,2))
	    else
	        days=days+b
	        do while(days<1)
	            y=y-1
	            days=days+daysofyear(y)
	        end do
	        DatePlusInt=todate(y,int(days,2))
	    end if

    contains
        !ÿ
        function daysofyear(year)
            integer(2),intent(in)::year
            integer(2) daysofyear
	        if(leapyear(y)) then
	            daysofyear=366
	        else
	            daysofyear=365
	        end if
        end function daysofyear
        
        !n
        function ToDate(year,n)
            integer(2),intent(in)::year,n
            type(date) ToDate
            integer(1) m,cd(11),i
            integer(2) n1
            
            cd=(/31,28,31,30,31,30,31,31,30,31,30/)
            if(leapyear(year)) cd(2)=29
            m=1;n1=n
            do i=1,11
                if(n1>cd(i)) then
                    m=m+1
                    n1=n1-cd(i)
                else
                    exit
                end if
            end do
            todate%year=year
            todate%month=m
            todate%day=n1
        end function ToDate        
	end function DatePlusInt
	
    
!************************************************************
! (-)غ,Date
! ܣ     Date
! ֵ   DateMinusDate(4ֽ),Date
!  a,b(ΪDateͱ)ֱ
!************************************************************
	function DateMinusDate(a,b) 
	    implicit none
	    type(Date),intent(in) :: a,b
	    type(Date) a1,b1,c1
	    logical(1) lgc
	    integer(4) DateMinusDate
	    integer(2) i

	    lgc=.false.
	    a1=a;b1=b
	    DateMinusDate=(a1%year-b1%year)*10000+(a1%month-b1%month)*100+a1%day-b1%day
	    if(DateMinusDate/=0) then
	        !ʹab
            if(DateMinusDate<0) then
            c1=a1;a1=b1;b1=c1
            lgc=.true.
            end if
            !ڷֱǵĵij,i-jֵ
            DateMinusDate=GetDayOrder(a1%year,a1%month,a1%day)-GetDayOrder(b1%year,b1%month,b1%day)
            do i=b1%year,a1%year-1
                if(leapyear(i)) then
                    DateMinusDate= DateMinusDate+366
                else
                    DateMinusDate= DateMinusDate+365
                end if
            end do
            if(lgc) DateMinusDate= -DateMinusDate
        end if
	end function DateMinusDate
	
	
	!ֵ(=)غ,Date
	subroutine AssignToDate(a,b)
	    implicit none
	    type(date),intent(in) :: b
	    type(date),intent(out) :: a
	    integer(1),parameter :: cd(12)=(/31,28,31,30,31,30,31,31,30,31,30,31/)
	    integer(1) m
    	
	    a%year=abs(b%year)
	    m=abs(b%month)
	    if(m<1.or.m>12) m=12
	    a%month=m
	    if(m==2) then
	        if(leapyear(a%year)) then
	            m=29
	        else
	            m=28
	        end if
	    else
	        m=cd(m)
	    end if
	    a%day=abs(b%day)
	    if(a%day>m .or. a%day<1) a%day=m
	end subroutine AssignToDate


!************************************************************
! ܣ     صǰǽĵڼ
! ֵ   GetDayOrder(2ֽ),
!  year,month,day(Ϊ2ֽ)ֱ!
!            ꡢ¡
!************************************************************
function GetDayOrder(year,month,day)
    implicit none
    integer(2),intent(in) :: year
    integer(1),intent(in) :: month,day
    integer(1),parameter :: cd(11)=(/31,28,31,30,31,30,31,31,30,31,30/)
    integer(2) GetDayOrder
    integer(1) i
    
    GetDayOrder=day
    do i=1,month-1
        GetDayOrder=GetDayOrder+cd(i)
    end do
    if(month>2.and.leapyear(year)) GetDayOrder=GetDayOrder+1
end function GetDayOrder	
	
!************************************************************
! ܣ     ò(Zeller)ʽ
! ֵ   week(1ֽ),0-6ֱ-
!  year(2ֽ),month(1ֽ),day(1ֽ)
!            ֱ:ꡢ¡
!************************************************************
function Week(year,month,day)
    implicit none
    integer(2),intent(in) :: year
    integer(1),intent(in) :: month,day
    integer(1) week,c
    integer(2) y,m
    
    y=year; m=month
    !ÿ12µһ1314´
    if(m<3) then
    y=y-1; m=m+12
    end if
    c=int(y/100); y=mod(y,100);m=(m+1)*13
    y=y+day-1-(c+c)+int(c/4)+int(y/4)+int(m/5)
    week=mod(y,7)
    !ֹȡΪ
    if(week<0) week=week+7
end function Week

!************************************************************
! ܣ     жǷ
! ֵ   LeapYear(1ֽ߼),򷵻.true.
!  year(2ֽ)
!************************************************************
function LeapYear(year)
    implicit none
    integer(2),intent(in) :: year
    logical(1) LeapYear
    
    if(mod(year,4)/=0) then
        LeapYear=.false.
    else if(mod(year,100)/=0) then
        LeapYear=.true.
    else if(mod(year,400)/=0) then
        LeapYear=.false.
    else
        LeapYear=.true. 
    end if
end function LeapYear

end module Li913_Date_class
